using System.Net.Http.Json;
using Amazon.Lambda.Core;
using Amazon.SecretsManager.Model;

// Assembly attribute to enable the Lambda function's JSON input to be converted into a .NET class.
[assembly: LambdaSerializer(typeof(Amazon.Lambda.Serialization.SystemTextJson.DefaultLambdaJsonSerializer))]

namespace LambdaSecretsManagerCachedLayer;

public class Function
{
    private readonly HttpClient _httpClient;
    public Function()
    {
        _httpClient = new HttpClient() { BaseAddress = new Uri("http://localhost:2773") };
        _httpClient.DefaultRequestHeaders.Add("X-AWS-Parameters-Secrets-Token", Environment.GetEnvironmentVariable("AWS_SESSION_TOKEN"));
    }
    
    public async Task<string> FunctionHandler(ILambdaContext context)
    {
        string secretId = "my-credentials";

        var secret = await _httpClient.GetFromJsonAsync<GetSecretValueResponse>($"/secretsmanager/get?secretId={secretId}");
        return secret.SecretString;
    }
}